//////////////////////////////////////////////////////////////
//
// Blt.CPP
//
// This is the source file for the NewGPE display driver
// class that contains the functionality related to bit
// blits.
//
//////////////////////////////////////////////////////////////

///////////////////////////////////
//
// Includes
//

#include <windows.h>
#include <types.h>
#include "NewGPE.h"

///////////////////////////////////
//
// Constants
//

///////////////////////////////////
//
// Globals
//

///////////////////////////////////
//
// Function Prototypes
//

///////////////////////////////////
//
// Functions
//

//////////////////////////////////////////////////////////////
//
// NewGPE::BltPrepare
//
// Prepare for a bit blit operation. This function overrides
// the base GPE class pure virtual function.
//
// PARAMETERS
// pBltParms    parameters for bit blit
//
// RETURNS
// S_OK if successful, otherwise an error code
//
// NOTES
// Default functionality is already implemented. Only
// override or change for non-default behavior such as
// hardware acceleration.
//
SCODE NewGPE::BltPrepare( GPEBltParms *pBltParms )
{
	// use the default blit function
    pBltParms->pBlt = EmulatedBlt;

	return S_OK;
}

//////////////////////////////////////////////////////////////
//
// NewGPE::BltComplete
//
// Completion after a bit blit operation. This function
// overrides the base GPE class pure virtual function.
//
// PARAMETERS
// pBltParms    parameters for bitblit
//
// RETURNS
// S_OK if successful, otherwise an error code
//
// NOTES
// Default functionality is already implemented. Only
// override or change for non-default behavior such as
// hardware acceleration.
//
SCODE NewGPE::BltComplete( GPEBltParms *pBltParms )
{
	// don't need to do anything here

    return S_OK;
}
