// viewererrors.cpp
// copyright (C) 2000 by David Cox All Rights Reserved

#include "cereserror.h"
#include <memory.h>

CeresError::CeresError()
{
	m_num = 0;
	memset(m_msg, 0, sizeof(m_msg));

	m_line = 0;
	memset(m_file, 0, sizeof(m_file));
}


CeresError::CeresError(const CeresError & e)
{
	memcpy(m_msg, e.m_msg, sizeof(m_msg));
	memcpy(m_file, e.m_file, sizeof(m_file));
	m_line = e.m_line;
}


CeresError & CeresError::operator=(const CeresError & e)
{
	if (this == &e) return *this;

	memcpy(m_msg, e.m_msg, sizeof(m_msg));
	memcpy(m_file, e.m_file, sizeof(m_file));
	m_line = e.m_line;

	return *this;
}


int CeresError::Num()
{
	return m_num;
}


void CeresError::Msg(const char * msg)
{
	memset(m_msg, 0, sizeof(m_msg));
	memcpy(m_msg, msg, sizeof(m_msg)-1);
}


const char * CeresError::Msg()
{
	return m_msg;
}


void CeresError::Line(unsigned line)
{
	m_line = line;
}


void CeresError::File(const char * file)
{
	memset(m_file, 0, sizeof(m_file));
	memcpy(m_file, file, sizeof(m_file)-1);
}


unsigned CeresError::Line()
{
	return m_line;
}


const char * CeresError::File()
{
	return m_file;
}


