package keepalive.communication;

/**
 * An object that receives messages.
 */
public interface Receiver {
    /**
     * The last time data was received.
     *
     * @return the time when data was last received, in millis since the
     *     Dawn of the Disco Era. If data has not yet been received, return
     *     the time of instantiation of this Object.
     */
    public long lastTimeStamp();

    /**
     * Set the call-back object that will be notified whenever data arrives.
     *
     * @param listener the call back object.
     */
    public void setMessageListener(MessageListener listener);
}
