package keepalive.keepalive;

import keepalive.communication.Sender;
import keepalive.communication.Receiver;

/**
 * This Keep-Alive actually does nothing; it is a placeholder, 
 * a "Null Object" as in the Null Object design pattern.
 *
 * @author Joshua Fox
 */
public class NullKeepAlive extends KeepAlive {
    /**
     * @param receiver
     * @param sender
     */
    public NullKeepAlive(Receiver receiver, Sender sender) {
        super(null, null);
    }

    /**
     */
    public NullKeepAlive() {
    }

    /**
     * Just sleep forever.
     */
    public void run() {
        try {
            sleep(Long.MAX_VALUE);
        } catch (InterruptedException ie) {
        }
    }
}
