package keepalive.socket.adapter;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;
import keepalive.socket.AbstractSocket;

/**
 * An adapter class which adapts TCP/IP sockets to our AbstractSocket class.
 *
 */
public class SocketAdapter extends AbstractSocket {
    private Socket socket;

    /**
     * Create an adapter for a new socket that will connect to ServerSocket
     */
    public SocketAdapter(InetAddress addr, int port)  throws IOException{

          socket = new Socket(addr, port);
    }


    /**
     * Create an adapter for a spunn-off socket (from a
     * ServerSocket on accept()
     */
    public SocketAdapter(Socket socket) {
        this.socket = socket;
    }

    /**
    */
    public InputStream getInputStream() throws IOException {
        return socket.getInputStream();
    }

    /**
    */
    public OutputStream getOutputStream() throws IOException {
        return socket.getOutputStream() ;
    }

    /**
    */
    public  void closeSocket() throws IOException {
         socket.close();
    }

    /**
    */
    public String toString() {
         String s = this.getClass().getName();
         if (socket != null) {
                s+= "-" + socket;
         }

         return s;
    }
}
