package keepalive.socket.sim.ui;

import java.awt.*;
import java.awt.event.*;

import keepalive.socket.sim.SimSocket;
import keepalive.socket.sim.SimHost;

/**
 * Provides a button for a simulated "unplugging" and
 * "plugging in" of our simulated host machine.
 */
public class PlugPanel extends Panel {
    /**
    */
    Button button = new Button();
    /**
    */
    BorderLayout borderLayout1 = new BorderLayout();

    /**
    */
    private SimHost host;

    /**
    */
    public PlugPanel(SimHost host) {
        this.host = host;
        jbInit();
    }

    /**
    */
    private void jbInit() {
        setLayout(borderLayout1);

        add(button, BorderLayout.CENTER);

        setPluggedIn(true);
        button.addActionListener(new java.awt.event.ActionListener() {
           /**             */
           public void actionPerformed(ActionEvent ev) {
                setPluggedIn(!host.isPluggedIn());
            }
        });
    }


    /**
    */
    private void setPluggedIn(boolean b) {
        host.setPluggedIn(b);
        if (host.isPluggedIn()) {
            button.setLabel("Unplug me");
            button.setBackground(Color.green);
        } else {
            button.setLabel("Plug me in");
            button.setBackground(Color.red);
        }
    }
}

