package keepalive.socket.sim.ui;

import java.awt.*;
import java.awt.event.*;

import keepalive.ui.KeepAliveUI;


/**
 * A Frame for holding the user-interface for a simulated host.
 * This is built from the simulated netstat and the keep-alive
 * user interface.
 *
 * @author Joshua Fox
 */
public class SimHostFrame extends Frame {
     /**     
       */
     public SimHostFrame(NetstatUI netstatUI, KeepAliveUI keepAliveUI, boolean serverSide) {
        setTitle("SimHost: " + (serverSide?"Server":"Client"));
        setLayout(new GridLayout(1, 2));
        addWindowListener(new java.awt.event.WindowAdapter() {
            /**              */
            public void windowClosing(WindowEvent e) {
                dispose();
                System.exit(0);
            }
        });

        add(netstatUI, null);
        add(keepAliveUI, null);

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        int horizSize = (int)(0.5 * screenSize.width);
        int vertSize =  (int)(0.8 * screenSize.height);
        setSize(horizSize, vertSize);

        double horizFraction = serverSide ? 0.0 : 0.5;
        int horizLoc = (int)(horizFraction * screenSize.width);
        int vertLoc = (int)(0.1 * screenSize.height);
        setLocation(horizLoc, vertLoc);

        setVisible(true);
     }
}
