package keepalive.ui;

import java.awt.*;
import java.awt.event.*;
import java.io.IOException;
import keepalive.apps.Client;

/**
 * The Keep-Alive user interface to be displayed on the server-side.
 */
public class ClientKeepAliveUI extends KeepAliveUI {
    private Client myClient;

    /**
     * Create a new Keep-Alive user interface for the client side
     * @param client is the client that will connect to server.
     * A button for connecting to server is added to panel.
     */
    public ClientKeepAliveUI(Client client) {
        myClient = client;
        Button connectButton = new Button("Connect");
        connectButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ev) {
                openConnectionToServer();
            }
        });

        buttonPanel.add(connectButton, null);   // buttonPanel is in superclass
        setVisible(true);
    }


    /**
     *  Open a new connection to the server.
     */
    public void openConnectionToServer() {
        myClient.openConnectionToServer();
    }
}