package keepalive.ui;


/**
 * Call-back interface which is notified when there is a message
 * to display in a user interface.
 */
public interface MessageDisplayer {
    /**
     * Called when there is a message to display in a user interface.
     *
     * @param participantName the application ("Server"/"Client") for whom the
     *      message is to be displayed.
     * @param message the message to be displayed.
     * @param sending whether the message is being sent (rather than being
     *     received).
     */
   public void display(String participantName, String message, boolean sending);
}
