//////////////////////////////////////////////////////////////
//
// Line.CPP
//
// This is the source file for the NewGPE display driver
// class that contains the functionality related to line
// drawing.
//
//////////////////////////////////////////////////////////////

///////////////////////////////////
//
// Includes
//

#include <windows.h>
#include <types.h>
#include "NewGPE.h"

///////////////////////////////////
//
// Constants
//

///////////////////////////////////
//
// Globals
//

///////////////////////////////////
//
// Function Prototypes
//

///////////////////////////////////
//
// Functions
//

//////////////////////////////////////////////////////////////
//
// NewGPE::Line
//
// Line drawing operation. This function overrides the base
// GPE class pure virtual function.
//
// PARAMETERS
// pLineParms   parameters for line drawing
// phase        indicates the current phase of line drawing
//              process
//
// RETURNS
// S_OK if successful, otherwise an error code
//
// NOTES
// Default functionality is already implemented. Only
// override or change for non-default behavior such as
// hardware acceleration.
//
SCODE NewGPE::Line(
				  GPELineParms *pLineParms,
				  EGPEPhase phase /*= gpeSingle */ )
{
	// use the default line function
    pLineParms->pLine = GPE::EmulatedLine;

	return S_OK;
}
