// parser.cpp
// copyright (C) 2000 by David Cox All Rights Reserved

#include "Parser.h"
#include <string.h>


Parser::Parser()
{
	memset(m_command, 0, e_commandSize);
	memset(m_param, 0, e_paramSize);
}


void Parser::NextToken(const char * s)
{
	m_next = strstr(s, "<!-- !");
	if (m_next == 0) return;

	m_next += strlen("<!-- !");
}


void Parser::NextCommand()
{
	memset(m_command, 0, e_commandSize);

	if (!m_next)
		return;

	int n = 0;
	while ((*m_next != ' ') && (n < e_commandSize-1))
	{
		if (m_next == 0) break;
		m_command[n] = *m_next;
		m_next++; n++;
	}
}


void Parser::NextParam()
{
	memset(m_param, 0, e_paramSize);

	if (!m_next)
		return;

	EatWhitespace();

	int n = 0;
	while ((strncmp(m_next, "-->", 3) != 0) && (n < e_paramSize-1))
	{
		if (m_next == 0) break;
		m_param[n] = *m_next;
		m_next++; n++;
	}
	
	m_next = strstr(m_next, "-->");
	if (m_next == 0) return;

	m_next += strlen("-->");
}


void Parser::EatWhitespace()
{
	if (!m_next) return;

	while (*m_next == ' ') m_next++;
}


char * Parser::Parse(const char * s)
{
	NextToken(s);
	NextCommand();
	NextParam();
	return m_next;
}


char * Parser::Command()
{
	return m_command;
}


char * Parser::Param()
{
	return m_param;
}

