#ifndef SqlToJavascriptParser_h
#define SqlToJavascriptParser_h

#include "database.h"


class SqlToJavascriptParser
{
public:

	enum {
		e_sqlSize = 1600,
		e_queryNameSize = 64,
		e_paramSize = 1600,
		e_substituteSize = 64,
		e_datasourceSize = 128,
		e_useridSize = 32,
		e_passwordSize = 8
	};

	SqlToJavascriptParser();
	SqlToJavascriptParser(const SqlToJavascriptParser &);
	~SqlToJavascriptParser();
	SqlToJavascriptParser &operator=(const SqlToJavascriptParser &);

	void PrintResultTable(const char * param);
	void PrintMaxPages(const char * param);

private:

	class		MissingQuery {};
	class		MissingQueryName {};

	char		m_sql[e_sqlSize];
	char		m_queryName[e_queryNameSize];
	char		m_datasource[e_datasourceSize];
	char		m_userid[e_useridSize];
	char		m_password[e_passwordSize];

	Table		* m_table;
	Database	m_database;
	int			m_page;
	int			m_pagesize;
	int			m_nRows;

	void SaveQueryName(const char * param, int & p);
	void SaveDatasource(const char * param, int & p);
	void SaveUserid(const char * param, int & p);
	void SavePassword(const char * param, int & p);
	void SaveQuery(const char * param, int & p);
	void SavePage();
	void SavePageSize();

	void Substitute(const char * param, int & p, int & s);
	void ParseParam(const char *);
	void Select();
};


#endif
