//
//=======================================================================
// Copyright 1997, 1998, 1999, 2000 University of Notre Dame.
// Authors: Andrew Lumsdaine, Lie-Quan Lee, Jeremy G. Siek
//
// This file is part of the Generic Graph Component Library
//
// You should have received a copy of the License Agreement for the
// Generic Graph Component Library along with the software;  see the
// file LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN  46556.
//
// Permission to modify the code and to distribute modified code is
// granted, provided the text of this NOTICE is retained, a notice that
// the code was modified is included with the above COPYRIGHT NOTICE and
// with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
// file is distributed with the modified code.
//
// LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
// By way of example, but not limitation, Licensor MAKES NO
// REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
// PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
// OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
// OR OTHER RIGHTS.
//=======================================================================
//
#ifndef GGCL_BASE_VISITOR_H
#define GGCL_BASE_VISITOR_H

namespace ggcl {

  struct every_edge_tag;

  template <class Visitor>
  struct base_visitor {
    typedef every_edge_tag category;
    //!wheredef: Visitor
    template <class Vertex>
    inline void initialize(Vertex u) { }
    //!wheredef: Visitor
    template <class Vertex>
    inline void start(Vertex s) { }
    //!wheredef: Visitor
    template <class Vertex>
    inline void discover(Vertex s) { }
    //!wheredef: Visitor
    template <class Vertex>
    inline void finish(Vertex s) { }
    //!wheredef: Visitor
    template <class Edge, class Graph>
    inline bool process(Edge e, Graph& g) { return true; }
  };
}

#endif
