//
//=======================================================================
// Copyright 1997, 1998, 1999, 2000 University of Notre Dame.
// Authors: Andrew Lumsdaine, Lie-Quan Lee, Jeremy G. Siek
//
// This file is part of the Generic Graph Component Library
//
// You should have received a copy of the License Agreement for the
// Generic Graph Component Library along with the software;  see the
// file LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN  46556.
//
// Permission to modify the code and to distribute modified code is
// granted, provided the text of this NOTICE is retained, a notice that
// the code was modified is included with the above COPYRIGHT NOTICE and
// with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
// file is distributed with the modified code.
//
// LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
// By way of example, but not limitation, Licensor MAKES NO
// REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
// PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
// OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
// OR OTHER RIGHTS.
//=======================================================================
//
#ifndef GGCL_DIRECTED_CATEGORY_TRAITS_H
#define GGCL_DIRECTED_CATEGORY_TRAITS_H

#include <boost/graph_structure.hpp>

namespace ggcl {

  struct directedS {};
  struct undirectedS {};
  struct directed_tag {};
  struct undirected_tag {};

  template <typename DirectedS>
  struct directed_category_traits {
    typedef directed_tag directed_category;
  };

  template <>
  struct directed_category_traits<directedS> {
    typedef directed_tag directed_category;
  };
  template <>
  struct directed_category_traits<undirectedS> {
    typedef undirected_tag directed_category;
  };

    
}

#endif /*GGCL_DIRECTED_CATEGORY_TRAITS_H*/
