
// function returns a pointer to the NewGPE instance so that
// functions within the class can be accessed directly.
/
NewGPE *GetGPEPointer()
{
    // GetGPE function pointer
    GPE* (*pfGetGPE)();

    // load the display driver DLL
    HANDLE hDDI = LoadLibrary( TEXT("DDI.DLL") );
    // make sure there is no error in loading
    if (!hDDI)
        return NULL;

    // get the function pointer
    pfGetGPE = (void *) GetProcAddress( hDDI, TEXT("GetGPE") );
    // make sure there is no error in getting the function pointer
    if (!pfGetGPE)
        return NULL;

    NewGPE *pGPE = (NewGPE *) (*pfGetGPE)();

    return pGPE;
}
