// main.cpp
// copyright (C) 2000 by David Cox All Rights Reserved

#include <windows.h>
#include <sql.h>
#include <sqlext.h>
#include <stdio.h>
#include <iostream.h>
#include "cgi.h"
#include "htmlreader.h"
#include "commandtable.h"
#include "cereserror.h"

Cgi cgi;

void TestEnv()
{
	// get the environment variables
	Env &e = cgi.GetEnv();
}


void Init()
{
	cgi.InitEnv();
	cgi.InitQuery();
	cgi.ParseQuery();
	cgi.ParseCookie();
}


main(int argc, char * argv[])
{
	try
	{

		// print http header
		// this step is necessary to see errors during init
		cgi.PrintContentTypeHeader("text/html");
		cout << endl;

		// initialize this process
		Init();

		// create an html reader and command object
		HtmlReader r;
		CommandTable command;

		// read an translate the html if available
		char * htmlpage = cgi.GetQueryValue("htmlpage");
		if (htmlpage)
		{
			r.Read(htmlpage);
			r.Translate(command);
		}
		else
		{
			cout << endl;
			cgi.PrintHtmlHeader();
			cgi.PrintHtmlTail();
		}

		return 0;
	}

	catch (CeresError & excp)
	{
		cout << "</SCRIPT></HEAD><BODY>" << endl;
		cout << "<P> ERROR: " << excp.Msg() << "</P>" << endl;
		cout << "<P> FILE:  " << excp.File() << ":" << excp.Line() << "</P>" << endl;
		cout << "</BODY></HTML>" << endl;
	}
}