//
//=======================================================================
// Copyright 1997, 1998, 1999, 2000 University of Notre Dame.
// Authors: Andrew Lumsdaine, Lie-Quan Lee, Jeremy G. Siek
//
// This file is part of the Generic Graph Component Library
//
// You should have received a copy of the License Agreement for the
// Generic Graph Component Library along with the software;  see the
// file LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN  46556.
//
// Permission to modify the code and to distribute modified code is
// granted, provided the text of this NOTICE is retained, a notice that
// the code was modified is included with the above COPYRIGHT NOTICE and
// with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
// file is distributed with the modified code.
//
// LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
// By way of example, but not limitation, Licensor MAKES NO
// REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
// PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
// OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
// OR OTHER RIGHTS.
//=======================================================================
//
/*****************************************************************************/
/*                                                                           */
/* Generative Matrix Package  -  File "Equal.h"                              */
/*                                                                           */
/*                                                                           */
/* Category:   Helper classes                                                */
/*                                                                           */
/* Meta-Functions:                                                           */
/* - EQUAL                                                                   */
/*                                                                           */
/*                                                                           */
/* EQUAL checks two values for equality at compile time. This function       */
/* is necessary because a simple expression 'a == b' doesn't work in every   */
/* metafunction                                                              */
/* (e.g. does not in IF).                                                    */
/*                                                                           */
/*                                                                           */
/* (c) Tobias Neubert, Krzysztof Czarnecki, and Ulrich Eisenecker 1998       */
/*                                                                           */
/*****************************************************************************/

// EQUAL

#ifndef _META_EQUAL_
#define _META_EQUAL_


template<int n1, int n2>
struct EQUAL
{
	enum {RET= n1==n2 ? 1:0};
};

#endif
