/*************************************************************************/
/*                                                                       */
/* Generative Matrix Package  -  File "IF.h"                             */
/*                                                                       */
/*                                                                       */
/* Category:   Helper classes                                            */
/*                                                                       */
/* Meta-Functions:                                                       */
/* - IF                                                                  */
/*                                                                       */
/*                                                                       */
/* IF provides an if-then-else metafunction which works with VC++5.0.    */
/* Some additional classes are needed to work around some compiler       */
/* problems.                                                             */
/*                                                                       */
/*                                                                       */
/* (c) Tobias Neubert, Krzysztof Czarnecki, and Ulrich Eisenecker 1998   */
/*                                                                       */
/*************************************************************************/

#ifndef _IF_
#define _IF_

#include <ggcl/ggcl_config.h>

namespace ggcl {

#ifdef GGCL_PARTIAL_SPECIALIZATION

  template <int cond, class A, class B>
  struct IF { typedef A RET; };
  template <class A, class B>
  struct IF<0, A, B> { typedef B RET; };

#else

template<int condition, class A, class B>struct IF;
template<int condition>struct SlectSelector;
struct SelectFirstType;
struct SelectSecondType;


struct SelectFirstType
{
  template<class A, class B>
  struct Template
  {
    typedef A RET;
  };
};

struct SelectSecondType
{
  template<class A, class B>
  struct Template
  {
    typedef B RET;
  };
};


template<int condition>
struct SlectSelector
{
  typedef SelectFirstType RET;
};


template <>
struct SlectSelector<0>
{

  typedef SelectSecondType RET;
};


template<int condition, class A, class B>
struct IF
{
  typedef typename SlectSelector<condition>::RET selector;
  typedef typename selector:: GGCL_TEMPLATE Template<A, B>::RET RET;
};

#endif

} /* namespace mtl */

#endif /* _IF_ */

